stages:
  - custom
  - smoke
  - full_without_smoke
  - full

variables:
  RELEASE: "EE"
  TEST_SUITE_SELECTION:
    description: "The test suites to run."
    value: 'Full'
    options:
      - Full
      - Full without Smoke
      - Smoke
      - Custom
  BUILDER_IMAGE_REVISION: "4.26.0"
  BUILDER_IMAGE_REGISTRY: "registry.gitlab.com/gitlab-org/gitlab-omnibus-builder"
  QA_CAN_TEST_GIT_PROTOCOL_V2: "false"
  QA_CAN_TEST_PRAEFECT: "false"
  QA_ENVIRONMENT_URL:
    description: "The URL to the target GitLab instance."
  ROOT_PASSWORD:
    description: "Password for the `root` user on the target GitLab instance."
  QA_IMAGE:
    description: "QA image to use against the environment. If not specified, will use Nightly QA image by default."

.rules:manual-when-mr-or-web:
  rules:
    - if: $CI_PIPELINE_SOURCE == "web" || $CI_PIPELINE_SOURCE == "merge_request_event"
      when: manual

.qa:
  image: "${BUILDER_IMAGE_REGISTRY}/distribution_ci_tools:${BUILDER_IMAGE_REVISION}"
  services:
    - docker:dind
  stage: test
  variables:
    DOCKER_HOST: tcp://docker:2375
    QA_ARTIFACTS_DIR: $CI_PROJECT_DIR
    QA_CAN_TEST_PRAEFECT: "false"
    QA_DEBUG: "true"
    GITLAB_USERNAME: root
    GITLAB_ADMIN_USERNAME: root
    SIGNUP_DISABLED: "true"
    GITLAB_ADMIN_PASSWORD: $ROOT_PASSWORD
    GITLAB_PASSWORD: $ROOT_PASSWORD
  script:
    - gem install gitlab-qa
    - if [ -n "$QA_IMAGE" ]; then
    - echo "QA image is set to $QA_IMAGE"
    - else
    - QA_IMAGE="gitlab/gitlab-ee-qa:nightly" # this will default to use nightly https://gitlab.com/gitlab-org/gitlab-qa/-/blob/master/docs/what_tests_can_be_run.md#specifying-the-gitlab-version
    - fi;
    - echo "Running - 'gitlab-qa Test::Instance::Any --qa-image $QA_IMAGE EE $QA_ENVIRONMENT_URL -- $TEST_SUITE'"
    - gitlab-qa Test::Instance::Any --qa-image $QA_IMAGE $RELEASE $QA_ENVIRONMENT_URL -- $TEST_SUITE
  artifacts:
    when: always
    expire_in: 7d
    paths:
      - ./gitlab-qa-run-*
  allow_failure: true
  needs: []

full:
  stage: full
  rules:
    - if: $TEST_SUITE_SELECTION == 'Full' && $CI_PIPELINE_SOURCE == "web"
    - !reference [.rules:manual-when-mr-or-web, rules]
  extends:
    - .qa
  parallel: 10
  variables:
    TEST_SUITE: "--tag ~skip_live_env --tag ~orchestrated --tag ~transient"

full_without_smoke:
  stage: full_without_smoke
  rules:
    - if: $TEST_SUITE_SELECTION == 'Full without Smoke' && $CI_PIPELINE_SOURCE == "web"
    - !reference [.rules:manual-when-mr-or-web, rules]
  extends:
    - .qa
  parallel: 10
  variables:
    TEST_SUITE: "--tag ~smoke --tag ~skip_live_env --tag ~orchestrated --tag ~transient"

smoke:
  stage: smoke
  rules:
    - if: $TEST_SUITE_SELECTION == 'Smoke' && $CI_PIPELINE_SOURCE == "web"
    - !reference [.rules:manual-when-mr-or-web, rules]
  extends:
    - .qa
  parallel: 2
  variables:
    TEST_SUITE: "--tag smoke"

custom:
  stage: custom
  rules:
    - if: $TEST_SUITE_SELECTION == 'Custom' && $CI_PIPELINE_SOURCE == "web"
    - !reference [.rules:manual-when-mr-or-web, rules]
  extends: .qa
